#ifndef OUTPUT_H
#define OUTPUT_H

#define OUTPUT_FORMAT_NULL 0
#define OUTPUT_FORMAT_SC 1
#define OUTPUT_FORMAT_RAW 2
#define OUTPUT_FORMAT_WAVE 3
#define OUTPUT_FORMAT_MAIN 16

struct __attribute__((packed)) WAVE_header {
    char RIFF[4];
    uint32_t ChunkSize;
    char WAVE[4];
    char fmt[4];
    uint32_t Sc1Sz;
    uint16_t afmt;
    uint16_t channels;
    uint32_t SampleRate;
    uint32_t ByteRate;
    uint16_t BlockAlign;
    uint16_t bps;
    char data[4];
    uint32_t alength;
};

struct _output {
	char main_filename[255];
	FILE *file;
	struct WAVE_header *header;
	int sample_rate;
	int current_frame, target_frame_count;
	uint8_t bps: 7;
	uint8_t signed_samples: 1;
	uint8_t num_channels: 4;
	uint8_t lpf: 4;
	uint8_t format: 7;
	uint8_t file_open: 1;
	uint8_t device;
	struct ouput_channels {
		char filename[255];
		uint8_t format;
		uint8_t main_channel_num;
		FILE *file;
		struct WAVE_header *header;
	} channels[4];
};
#define OUTPUT_BUFFER_SIZE 1<<20
extern struct _output output;
extern uint8_t output_samples[OUTPUT_BUFFER_SIZE];

void nbtv_output(float channels[4][1<<17], uint8_t *key, int sc, struct NBTV_format *f, struct _output *of);
void setup_output(struct _output *o);
void start_output(struct _output *o);
void stop_output();
void set_output_format(struct _output *op);
void ms_wave_write_start(struct _output *op);
void audio_file_write_block(struct _output *op, uint8_t *samples, int count);
void audio_file_end(struct _output *op);

#endif